/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* BiDiPro/24RF08 v0.1.0                                           defines.h
* Copyright (c) Oleg O. Chukaev, 2008 <oleg.chukaev@mail.ru>
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/

#ifndef AT24RF08_DEFINES_H
#define AT24RF08_DEFINES_H


typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;


/* Port number and port address */
#define	LPT1ADR		0x0378
#define	LPT2ADR		0x0278
#define	LPT3ADR		0x03BC


/* 殮  㬮砭 */
#define DEFAULT_VCC	50
#define DEFAULT_VPP	50


#define NELEMS(array)	(sizeof(array) / sizeof(array[0]))


/*  . 䠩 */
#define INIFILE   "24rf08.cfg"


/* Program return codes */
#define	RC_FAIL		1
#define	RC_FILE		2
#define	RC_INIT		3
#define RC_DEV		4
#define	RC_SYNTAX	5


/*  EEPROM / APP */
#define	EEPROM_SIZE	1024
#define	APP_SIZE	32


/*  ࠭ EEPROM */
#define PAGE_SIZE 16


/* values for special_options */
#define SPECIAL_SHOW_HELP 0x01
#define SPECIAL_SHOW_VERSION 0x02
#define SPECIAL_SHOW_LICENSE 0x04


/*  EEPROM  APP */
#define I2C_EEP 0xA8
#define I2C_APP 0xB8


#endif /* AT24RF08_DEFINES_H */

/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* E0F
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/
