/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* BiDiPro/24RF08 v0.1.0                                            hwctrl.c
* Copyright (c) Oleg O. Chukaev, 2008  <oleg.chukaev@mail.ru>
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/


/*-------------------------------------------------------------------------
  砥 䠩
-------------------------------------------------------------------------*/


#include <dos.h>
#include "defines.h"
#include "bidi.h"


/*-------------------------------------------------------------------------
   ६
-------------------------------------------------------------------------*/

int port_number = 2;		/*  ࠫ쭮 : 1..3 */
int vcc = DEFAULT_VCC;		/* 殮 ⠭ ( 100 ) */
int vpp = DEFAULT_VPP;		/* 殮 ணࠬ஢ ( 100 ) */


/*-------------------------------------------------------------------------
   ६
-------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------
   㭪樨
-------------------------------------------------------------------------*/


/****************************************************************************
*  প.
* ࠬ:
*	dly -- প  .
* 頥:
*	---
****************************************************************************/

/* !!!  ??? */

void delay_ms (word dly) {

	delay (dly);
}


/****************************************************************************
* 砥 ⠭ , ॢ   ० ணࠬ஢.
* ࠬ:
*	---
* 頥:
*	---
****************************************************************************/

void power_on (void) {

	bdport (PFORCE | PWR1 | PBIN);		// DD1:OIO
	bdport (PFORCE | PWR2);			// DD4:OOO
	voltage (vcc, vpp, 140);
	bdport (PWB2 | 0x80);			//Vcc pin 36
	bdport (PWA2 | BITTER);			//WP set to A18
	delay (100);
}


/****************************************************************************
* 몫砥 ⠭ , 뢮   ० ணࠬ஢.
* ࠬ:
*	---
* 頥:
*	---
****************************************************************************/

void power_off (void) {
	bdport (PRST);
}


void scl (word b) {
	bdport (PWA1 | (b & 1));
	delay_us (10);
}

void sda (byte b) {
	bdport (PWB1 | (b & 1));
}


byte rsda (void) {
	return (bdport (PRB1) & 1);
}


void sda_out (void) {
	bdport (PFORCE | PWR1);		// DD1:OOO
}


void sda_in (void) {
	bdport (PFORCE | PWR1 | PBIN);	// DD1:OIO
}


/* start */
void i2c_start (void) {
	sda (1);
	scl (1);
	sda (0);
	scl (0);
}

/* stop */
void i2c_stop (void) {
	scl (0);
	sda (0);
	scl (1);
	sda (1);
}

// ਥ  i2c
byte read_i2c_byte (int ack) {

	word i;
	byte d = 0;

	sda_in ();  //switch SDA to input mode

	for (i = 0; i < 8; i++) {
		scl (1);
		d <<= 1;
		d += rsda ();
		scl (0);
	}
	sda_out ();   //switch SDA to output mode
	if (ack) {
		sda (0);
	} else {
		sda (1);
	}
	scl (1);
	scl (0);
	sda (0);
	return (d);
}

// ।  i2c
int write_i2c_byte (byte d) {

	word i;

	for (i = 0; i < 8; i++) {
		sda ((d & 0x80) >> 7);
		scl (1);
		d <<= 1;
		scl (0);
	}
	sda (0);
	sda_in ();   //switch SDA to input mode
	scl (1);
	i = rsda (); // 0 - 뫠 ⠭
	scl (0);
	sda_out ();   //switch SDA to output mode
	sda (0);       // Leave data line as an output
	return (i);
}


/****************************************************************************
* 樠 ணࠬ.
* ࠬ:
*	ᯮ ६ port_mode, port_number, vcc, vpp.
* 頥:
*	 訡: 0x0000 -- Ok, 0x01?? -- 訡, ?? -- . ࠩ.
****************************************************************************/

int initialize_port (void) {

	int rc;
	const word port_list[] = {LPT1ADR, LPT2ADR, LPT3ADR};

	portaddr = port_list[port_number-1];
	rc = init ();
	voltage (vcc, vpp, 140);
	return (rc);
}


/****************************************************************************
* 蠥 ࠡ ணࠬ.
* ࠬ:
*	---
* 頥:
*	---
****************************************************************************/

void close_port (void) {

	power_off ();
}


/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* E0F
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/

